//+------------------------------------------------------------------+
//|                        Digital Low Pass (FATL/SATL, KGLP) Filter |
//|                      Copyright (c) Sergey Iljukhin, Novosibirsk. |
//|                       email sergey[at]tibet.ru http://fx.qrz.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright (c) 2005, Sergey Iljukhin, Novosibirsk"
#property link      "http://fx.qrz.ru/"

// --- Parameters: P1=41, D1=12, A1=40
// --- P2=85, D2=84, A2=40, Ripple=0.08, Delay=8
// --- Order [Auto]=25, Calculate method=2

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Gold
#define FilterOrder 25

//---- buffers
double FilterBuffer[];

//+------------------------------------------------------------------+
//| Digital filter indicator initialization function                 |
//+------------------------------------------------------------------+
int init()
{
//---- indicator line
SetIndexStyle(0,DRAW_LINE);
SetIndexBuffer(0,FilterBuffer);
SetIndexDrawBegin(0,25);
//----
return(0);
}
//+------------------------------------------------------------------+
//| Digital filter main function                                     |
//+------------------------------------------------------------------+
int start()
{
int i,counted_bars=IndicatorCounted();
double response;
//----
if(Bars<=25) return(0);
//----
i=Bars-25-1;
if(counted_bars>=25) i=Bars-counted_bars-1;
while(i>=0)
{
response=
0.0335330866024*Close[i]
+0.0482700626447*Close[i+1]
+0.0637774222013*Close[i+2]
+0.0778991463501*Close[i+3]
+0.0900844324881*Close[i+4]
+0.0987348636242*Close[i+5]
+0.1033590404272*Close[i+6]
+0.1033590404272*Close[i+7]
+0.0987348636242*Close[i+8]
+0.0900844324881*Close[i+9]
+0.0778991463501*Close[i+10]
+0.0637774222013*Close[i+11]
+0.0482700626447*Close[i+12]
+0.0335330866024*Close[i+13]
+0.01946162519417*Close[i+14]
+0.00841017944418*Close[i+15]
-0.0010210277569*Close[i+16]
-0.00629647386713*Close[i+17]
-0.01048621003888*Close[i+18]
-0.0104053280779*Close[i+19]
-0.01104358698736*Close[i+20]
-0.00759190306848*Close[i+21]
-0.00731722351817*Close[i+22]
-0.00502615999922*Close[i+23];
FilterBuffer[i]=response;

i--;
}
return(0);
}

