//+------------------------------------------------------------------+
//|                        Digital Low Pass (FATL/SATL, KGLP) Filter |
//|                      Copyright (c) Sergey Iljukhin, Novosibirsk. |
//|                       email sergey[at]tibet.ru http://fx.qrz.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright (c) 2005, Sergey Iljukhin, Novosibirsk"
#property link      "http://fx.qrz.ru/"

// --- Parameters: P1=41, D1=12, A1=40
// --- P2=85, D2=84, A2=40, Ripple=0.08, Delay=8
// --- Order [Auto]=25, Calculate method=2

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
#define FilterOrder 25

//---- buffers
double FilterBuffer[];

//+------------------------------------------------------------------+
//| Digital filter indicator initialization function                 |
//+------------------------------------------------------------------+
int init()
{
//---- indicator line
SetIndexStyle(0,DRAW_LINE);
SetIndexBuffer(0,FilterBuffer);
SetIndexDrawBegin(0,25);
//----
return(0);
}
//+------------------------------------------------------------------+
//| Digital filter main function                                     |
//+------------------------------------------------------------------+
int start()
{
int i,counted_bars=IndicatorCounted();
double response;
//----
if(Bars<=25) return(0);
//----
i=Bars-25-1;
if(counted_bars>=25) i=Bars-counted_bars-1;
while(i>=0)
{
response=
 0.01909010080734*Close[i]
 +0.0328929365987*Close[i+1]
 +0.0473485822828*Close[i+2]
 +0.0625599047822*Close[i+3]
 +0.0764120437935*Close[i+4]
 +0.0883647115907*Close[i+5]
 +0.0968500051244*Close[i+6]
 +0.1013859059261*Close[i+7]
 +0.1013859059261*Close[i+8]
 +0.0968500051244*Close[i+9]
 +0.0883647115907*Close[i+10]
 +0.0764120437935*Close[i+11]
 +0.0625599047822*Close[i+12]
 +0.0473485822828*Close[i+13]
 +0.0328929365987*Close[i+14]
 +0.01909010080734*Close[i+15]
 +0.00824962827078*Close[i+16]
 -0.001001536234094*Close[i+17]
 -0.00617627354628*Close[i+18]
 -0.01028602723215*Close[i+19]
 -0.01020668931596*Close[i+20]
 -0.01083276379850*Close[i+21]
 -0.00744697287358*Close[i+22]
 -0.00717753698358*Close[i+23]
 -0.00493021009816*Close[i+24];
FilterBuffer[i]=response;

i--;
}
return(0);
}

