//+------------------------------------------------------------------+
//|                        Digital Low Pass (FATL/SATL, KGLP) Filter |
//|                      Copyright (c) Sergey Iljukhin, Novosibirsk. |
//|                       email sergey[at]tibet.ru http://fx.qrz.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright (c) 2005, Sergey Iljukhin, Novosibirsk"
#property link      "http://fx.qrz.ru/"

// --- Parameters: P1=41, D1=12, A1=40
// --- P2=85, D2=84, A2=40, Ripple=0.08, Delay=9
// --- Order [Auto]=26, Calculate method=2

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
#define FilterOrder 26

//---- buffers
double FilterBuffer[];

//+------------------------------------------------------------------+
//| Digital filter indicator initialization function                 |
//+------------------------------------------------------------------+
int init()
{
//---- indicator line
SetIndexStyle(0,DRAW_LINE);
SetIndexBuffer(0,FilterBuffer);
SetIndexDrawBegin(0,26);
//----
return(0);
}
//+------------------------------------------------------------------+
//| Digital filter main function                                     |
//+------------------------------------------------------------------+
int start()
{
int i,counted_bars=IndicatorCounted();
double response;
//----
if(Bars<=26) return(0);
//----
i=Bars-26-1;
if(counted_bars>=26) i=Bars-counted_bars-1;
while(i>=0)
{
response=
 0.00818212875013*Close[i]
 +0.01893390314468*Close[i+1]
 +0.0326238023565*Close[i+2]
 +0.0469611700864*Close[i+3]
 +0.0620480315867*Close[i+4]
 +0.0757868306131*Close[i+5]
 +0.0876417001435*Close[i+6]
 +0.0960575659130*Close[i+7]
 +0.1005563533903*Close[i+8]
 +0.1005563533903*Close[i+9]
 +0.0960575659130*Close[i+10]
 +0.0876417001435*Close[i+11]
 +0.0757868306131*Close[i+12]
 +0.0620480315867*Close[i+13]
 +0.0469611700864*Close[i+14]
 +0.0326238023565*Close[i+15]
 +0.01893390314468*Close[i+16]
 +0.00818212875013*Close[i+17]
 -0.000993341535679*Close[i+18]
 -0.00612573848093*Close[i+19]
 -0.01020186563301*Close[i+20]
 -0.01012317686987*Close[i+21]
 -0.01074412873038*Close[i+22]
 -0.00738604078273*Close[i+23]
 -0.00711880945187*Close[i+24]
 -0.00488987048437*Close[i+25];
FilterBuffer[i]=response;

i--;
}
return(0);
}

