//+------------------------------------------------------------------+
//|                        Digital Low Pass (FATL/SATL, KGLP) Filter |
//|                      Copyright (c) Sergey Iljukhin, Novosibirsk. |
//|                       email sergey[at]tibet.ru http://fx.qrz.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright (c) 2005, Sergey Iljukhin, Novosibirsk"
#property link      "http://fx.qrz.ru/"

// --- Parameters: P1=41, D1=12, A1=40
// --- P2=85, D2=84, A2=40, Ripple=0.08, Delay=0
// --- Order [Auto]=17, Calculate method=2
// --- Data Period 1H, 01jan08 12:00 to 07feb08 02:00

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Violet
#define FilterOrder 17

//---- buffers
double FilterBuffer[];

//+------------------------------------------------------------------+
//| Digital filter indicator initialization function                 |
//+------------------------------------------------------------------+
int init()
{
//---- indicator line
SetIndexStyle(0,DRAW_LINE, EMPTY, 2);
SetIndexBuffer(0,FilterBuffer);
SetIndexDrawBegin(0,17);
//----
return(0);
}
//+------------------------------------------------------------------+
//| Digital filter main function                                     |
//+------------------------------------------------------------------+
int start()
{
int i,counted_bars=IndicatorCounted();
double response;
//----
if(Bars<=17) return(0);
//----
i=Bars-17-1;
if(counted_bars>=17) i=Bars-counted_bars-1;
while(i>=0)
{
response=
 0.2134009687843*Close[i]
 +0.2038536296690*Close[i+1]
 +0.1859934562656*Close[i+2]
 +0.1608350196546*Close[i+3]
 +0.1316785027035*Close[i+4]
 +0.0996611238754*Close[i+5]
 +0.0692343227810*Close[i+6]
 +0.0401815811504*Close[i+7]
 +0.01736413606028*Close[i+8]
 -0.002108072129711*Close[i+9]
 -0.01300005899453*Close[i+10]
 -0.02165042720911*Close[i+11]
 -0.02148343370029*Close[i+12]
 -0.02280121944067*Close[i+13]
 -0.01567467599383*Close[i+14]
 -0.01510755693102*Close[i+15]
 -0.01037729654480*Close[i+16];
FilterBuffer[i]=response;

i--;
}
return(0);
}